﻿//------Config-------------------------------- 
//Only edit these lines, if you are not happy with the clock's appearance 
 
//Use Multiple LCDs as Timepanels 
bool multiLCD = true; 
 
//Clock format: 
//false=Clock uses 24-Hour format 
//true=Clock uses 12-Hour format   
bool twelveHours = false;  
 
//Fontsize: 
//Same range as in the Control Panel. Has to end with a "f" 
Single fontsize = 9.6f; 
 
//Time manipulation 
//In case you want to adjust the clock time 
int hoursToAdd = 0; 
int minutesToAdd = 0; 
int secondsToAdd = 0; 
//----------------------------------------------




void Main() {
    if(!multiLCD) {
        IMyTextPanel timePanel = (IMyTextPanel) GridTerminalSystem.GetBlockWithName("timepanel");
        timePanel.SetValueFloat("FontSize",fontsize);
        String time = getTimeString();
        timePanel.WritePublicText(time);
    }
    else {
        List<IMyTerminalBlock> allPanels = new List<IMyTerminalBlock>();  
 
        List<IMyTextPanel> timepanels = new List<IMyTextPanel>();  
 
        GridTerminalSystem.GetBlocksOfType<IMyTextPanel>(allPanels);   
 
        for(int i=0;i<allPanels.Count;i++) { 
            if(allPanels[i].CustomName.ToLower().Contains("timepanel")) {   
                timepanels.Add( (IMyTextPanel) GridTerminalSystem.GetBlockWithName(allPanels[i].CustomName)); 
            } 
        }
        String time = getTimeString();
        for(int i=0;i<timepanels.Count;i++) { 
            timepanels[i].SetValueFloat("FontSize",fontsize);
            timepanels[i].WritePublicText(time); 
        }

    }
}


String getTimeString() {
    TimeSpan addition = new TimeSpan(0,hoursToAdd,minutesToAdd,secondsToAdd); 
    DateTime saveNow = DateTime.Now; 
    saveNow = saveNow.Add(addition); 
    string format = (twelveHours ? "hh" : "HH");
    return saveNow.ToString(format+":mm:ss");
}